searchNodes=[{"doc":"Mix task to dump the content of the Tyyppi.Stats to disk. Command line options -t - the type pf the storage, dets or process ; default is ets -f - the name of the file to dump to; default is tyyppi.dets If the types are stored as -t process , the application using it must start the Tyyppi.Stats process with Tyyppi.Stats.load/3 specifying :process as the first parameter. For -t ets (default,) Tyyppi.Stats.load(:ets, file) should have been called.","ref":"Mix.Tasks.Tyyppi.Dump.html","title":"Mix.Tasks.Tyyppi.Dump","type":"task"},{"doc":"The main interface to Tyyppi library. Usually, functions and macros presented is this module are enough to work with Tyyppi .","ref":"Tyyppi.html","title":"Tyyppi","type":"module"},{"doc":"Experimental: applies the external function given as an argument in the form &amp;Module.fun/arity or anonymous function with arguments. Validates the arguments given and the result produced by the call. Examples: iex&gt; require Tyyppi ...&gt; Tyyppi . apply ( ( atom ( ) -&gt; binary ( ) ) , ...&gt; fn a -&gt; to_string ( a ) end , [ :foo ] ) { :ok , &quot;foo&quot; } ...&gt; result = Tyyppi . apply ( ( atom ( ) -&gt; binary ( ) ) , ...&gt; fn -&gt; &quot;foo&quot; end , [ :foo ] ) ...&gt; match? ( { :error , { :fun , _ } } , result ) true ...&gt; Tyyppi . apply ( ( atom ( ) -&gt; binary ( ) ) , ...&gt; fn _ -&gt; 42 end , [ &quot;foo&quot; ] ) { :error , { :args , [ &quot;foo&quot; ] } } ...&gt; Tyyppi . apply ( ( atom ( ) -&gt; binary ( ) ) , ...&gt; fn _ -&gt; 42 end , [ :foo ] ) { :error , { :result , 42 } }","ref":"Tyyppi.html#apply/2","title":"Tyyppi.apply/2","type":"macro"},{"doc":"Experimental: applies the local function given as an argument in the form &amp;Module.fun/arity or anonymous function with arguments. Validates the arguments given and the result produced by the call. Only named types are supported at the moment. If the number of arguments does not fit the arity of the type, returns {:error, {:arity, n}} where n is the number of arguments passed. If arguments did not pass the validation, returns {:error, {:args, [arg1, arg2, ...]}} where argN are the arguments passed. If both arity and types of arguments are ok, evaluates the function and checks the result against the type. Returns {:ok, result} or {:error, {:result, result}} if the validation did not pass. Example: require Tyyppi Tyyppi . apply ( MyModule . callback ( ) , &amp; MyModule . on_info / 1 , 2 ) #⇒ {:ok, [foo_squared: 4]} Tyyppi . apply ( MyModule . callback ( ) , &amp; MyModule . on_info / 1 , :ok ) #⇒ {:error, {:args, :ok}} Tyyppi . apply ( MyModule . callback ( ) , &amp; MyModule . on_info / 1 , [ ] ) #⇒ {:error, {:arity, 0}}","ref":"Tyyppi.html#apply/3","title":"Tyyppi.apply/3","type":"macro"},{"doc":"Returns true if the term passed as the second parameter is of type type . The first parameter is expected to be a type as in specs, e. g. atom() or GenServer.on_start() . Examples: iex&gt; require Tyyppi ...&gt; Tyyppi . of? ( atom ( ) , :ok ) true ...&gt; Tyyppi . of? ( atom ( ) , 42 ) false ...&gt; Tyyppi . of? ( GenServer . on_start ( ) , { :error , { :already_started , self ( ) } } ) true ...&gt; Tyyppi . of? ( GenServer . on_start ( ) , :foo ) false","ref":"Tyyppi.html#of?/2","title":"Tyyppi.of?/2","type":"macro"},{"doc":"Returns true if the term passed as the second parameter is of type type . The first parameter is expected to be of type Tyyppi.T.t(term()) . Examples: iex&gt; require Tyyppi ...&gt; type = Tyyppi . parse ( atom ( ) ) % Tyyppi.T { definition : { :type , 0 , :atom , [ ] } , module : nil , name : nil , params : [ ] , quoted : { :atom , [ ] , [ ] } , source : nil , type : :built_in } ...&gt; Tyyppi . of_type? ( type , :ok ) true ...&gt; Tyyppi . of_type? ( type , 42 ) false ...&gt; type = Tyyppi . parse ( GenServer . on_start ( ) ) ...&gt; Tyyppi . of_type? ( type , { :error , { :already_started , self ( ) } } ) true ...&gt; Tyyppi . of_type? ( type , :foo ) false","ref":"Tyyppi.html#of_type?/2","title":"Tyyppi.of_type?/2","type":"function"},{"doc":"Parses the type as by spec and returns its Tyyppi.T representation. Example: iex&gt; require Tyyppi ...&gt; parsed = Tyyppi . parse ( GenServer . on_start ( ) ) ...&gt; with % Tyyppi.T { definition : { :type , _ , :union , [ type | _ ] } } &lt;- parsed , do : type { :type , 0 , :tuple , [ { :atom , 0 , :ok } , { :type , 704 , :pid , [ ] } ] } ...&gt; parsed . module GenServer ...&gt; parsed . name :on_start ...&gt; parsed . params [ ] ...&gt; parsed . quoted { { :. , [ ] , [ GenServer , :on_start ] } , [ ] , [ ] } ...&gt; parsed . type :type","ref":"Tyyppi.html#parse/1","title":"Tyyppi.parse/1","type":"macro"},{"doc":"Sigil to simplify specification of Tyyppi.T.t(term()) type, it’s literally the wrapper for Tyyppi.parse/1 . Examples iex&gt; import Tyyppi iex&gt; ~t[integer()] % Tyyppi.T { definition : { :type , 0 , :integer , [ ] } , module : nil , name : nil , params : [ ] , quoted : { :integer , [ ] , [ ] } , source : nil , type : :built_in } ...&gt; ~t[atom] % Tyyppi.T { definition : { :type , 0 , :atom , [ ] } , module : nil , name : nil , params : [ ] , quoted : { :atom , [ ] , [ ] } , source : nil , type : :built_in }","ref":"Tyyppi.html#sigil_t/2","title":"Tyyppi.sigil_t/2","type":"macro"},{"doc":"Creates the typed struct with spec bound to each field. Usage See Tyyppi.Example.Struct for the example of why and how to use Tyyppi.Struct . Example iex&gt; defmodule MyStruct do ...&gt; @type my_type :: :ok | { :error , term ( ) } ...&gt; Tyyppi.Struct . defstruct foo : atom ( ) , bar : GenServer . on_start ( ) , baz : my_type ( ) ...&gt; end iex&gt; types = MyStruct . types ( ) ...&gt; types [ :foo ] % Tyyppi.T { definition : { :type , 0 , :atom , [ ] } , module : nil , name : nil , params : [ ] , source : nil , type : :built_in } ...&gt; types [ :baz ] % Tyyppi.T { definition : { :type , 0 , :union , [ { :atom , 0 , :ok } , { :type , 0 , :tuple , [ { :atom , 0 , :error } , { :type , 0 , :term , [ ] } ] } ] } , module : Test.Tyyppi.Struct.MyStruct , name : :my_type , params : [ ] , quoted : { { :. , [ ] , [ Test.Tyyppi.Struct.MyStruct , :my_type ] } , [ ] , [ ] } , source : :user_type , type : :type } Defaults Since there is no place for default values in the struct declaration, where types are first class citizens, defaults might be specified through @defaults module attribute. Omitted fields there will be considered having nil default value. iex&gt; % Tyyppi.Example.Struct { } % Tyyppi.Example.Struct { bar : { :ok , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } , baz : { :error , :reason } , foo : nil } Upserts iex&gt; { ex , pid } = { % Tyyppi.Example.Struct { } , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } iex&gt; Tyyppi.Example.Struct . update ( ex , foo : :foo , bar : { :ok , pid } , baz : :ok ) { :ok , % Tyyppi.Example.Struct { bar : { :ok , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } , baz : :ok , foo : :foo } } iex&gt; Tyyppi.Example.Struct . update ( ex , foo : :foo , bar : { :ok , pid } , baz : 42 ) { :error , [ baz : [ type : [ expected : &quot;Tyyppi.Example.Struct.my_type()&quot; , got : 42 ] ] ] } Access iex&gt; pid = :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) iex&gt; ex = % Tyyppi.Example.Struct { foo : :foo , bar : { :ok , pid } , baz : :ok } iex&gt; put_in ( ex , [ :foo ] , :foo_sna ) % Tyyppi.Example.Struct { bar : { :ok , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } , baz : :ok , foo : :foo_sna } iex&gt; put_in ( ex , [ :foo ] , 42 ) ** (ArgumentError) could not put/update key :foo with value 42 ([foo: [type: [expected: &quot;atom()&quot;, got: 42]]])","ref":"Tyyppi.Struct.html","title":"Tyyppi.Struct","type":"module"},{"doc":"Declares a typed struct. The accepted argument is the keyword of {field_name, type} tuples. See Tyyppi.Example.Struct for an example.","ref":"Tyyppi.Struct.html#defstruct/1","title":"Tyyppi.Struct.defstruct/1","type":"macro"},{"doc":"Puts the value to target under specified key, if passes validation","ref":"Tyyppi.Struct.html#put/3","title":"Tyyppi.Struct.put/3","type":"function"},{"doc":"Puts the value to target under specified key, if passes validation, raises otherwise","ref":"Tyyppi.Struct.html#put!/3","title":"Tyyppi.Struct.put!/3","type":"function"},{"doc":"Updates the value in target under specified key, if passes validation","ref":"Tyyppi.Struct.html#update/3","title":"Tyyppi.Struct.update/3","type":"function"},{"doc":"Updates the value in target under specified key, if passes validation, raises otherwise","ref":"Tyyppi.Struct.html#update!/3","title":"Tyyppi.Struct.update!/3","type":"function"},{"doc":"The behaviour all participants of the Tyyppi ’s operations should have implemented. It’s implemented by Tyyppi.Value and Tyyppi.Struct , making them available for deep nested validations, coercion and generation.","ref":"Tyyppi.Valuable.html","title":"Tyyppi.Valuable","type":"behaviour"},{"doc":"The coercion function, receiving the value()","ref":"Tyyppi.Valuable.html#c:coerce/1","title":"Tyyppi.Valuable.coerce/1","type":"callback"},{"doc":"Flattens the struct using the options passed","ref":"Tyyppi.Valuable.html#c:flatten/2","title":"Tyyppi.Valuable.flatten/2","type":"callback"},{"doc":"The generation function, returning the generator for the whole","ref":"Tyyppi.Valuable.html#c:generation/1","title":"Tyyppi.Valuable.generation/1","type":"callback"},{"doc":"The validation function, receiving the value()","ref":"Tyyppi.Valuable.html#c:validate/1","title":"Tyyppi.Valuable.validate/1","type":"callback"},{"doc":"Type returned from coercions and validations, typical pair of ok/error tuples, involving the value() as a main type behind","ref":"Tyyppi.Valuable.html#t:either/0","title":"Tyyppi.Valuable.either/0","type":"type"},{"doc":"Type of the generation function, basically returning a stream of generated values","ref":"Tyyppi.Valuable.html#t:generation/0","title":"Tyyppi.Valuable.generation/0","type":"type"},{"doc":"Type of the value behind the implementation","ref":"Tyyppi.Valuable.html#t:value/0","title":"Tyyppi.Valuable.value/0","type":"type"},{"doc":"Value type to be used with Tyyppi . It wraps the standard Elixir type in a struct, also providing optional coercion, validation, documentation, and Access implementation. Built-in constructors any   atom   string   boolean   integer   non_neg_integer   pos_integer   timeout   pid   mfa   mod_arg   fun   one_of   formulae   list  — creates a [type()] wrapped into a value struct","ref":"Tyyppi.Value.html","title":"Tyyppi.Value","type":"module"},{"doc":"Creates a not defined any() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#any/0","title":"Tyyppi.Value.any/0","type":"function"},{"doc":"Factory for any() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#any/1","title":"Tyyppi.Value.any/1","type":"function"},{"doc":"Creates a not defined atom() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#atom/0","title":"Tyyppi.Value.atom/0","type":"function"},{"doc":"Factory for atom() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#atom/1","title":"Tyyppi.Value.atom/1","type":"function"},{"doc":"Creates a not defined boolean() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#boolean/0","title":"Tyyppi.Value.boolean/0","type":"function"},{"doc":"Factory for boolean() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#boolean/1","title":"Tyyppi.Value.boolean/1","type":"function"},{"doc":"Creates a not defined date_time() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#date_time/0","title":"Tyyppi.Value.date_time/0","type":"function"},{"doc":"Factory for timeout() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#date_time/1","title":"Tyyppi.Value.date_time/1","type":"function"},{"doc":"Creates a not defined formulae wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#formulae/0","title":"Tyyppi.Value.formulae/0","type":"function"},{"doc":"","ref":"Tyyppi.Value.html#formulae/1","title":"Tyyppi.Value.formulae/1","type":"function"},{"doc":"Factory for formulae wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#formulae/2","title":"Tyyppi.Value.formulae/2","type":"function"},{"doc":"Creates a not defined fun wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#fun/1","title":"Tyyppi.Value.fun/1","type":"function"},{"doc":"Creates a not defined integer() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#integer/0","title":"Tyyppi.Value.integer/0","type":"function"},{"doc":"Factory for integer() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#integer/1","title":"Tyyppi.Value.integer/1","type":"function"},{"doc":"Helper guard to match instances of struct Formulae","ref":"Tyyppi.Value.html#is_formulae/1","title":"Tyyppi.Value.is_formulae/1","type":"macro"},{"doc":"Creates a not defined list wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#list/0","title":"Tyyppi.Value.list/0","type":"function"},{"doc":"Factory for list wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#list/1","title":"Tyyppi.Value.list/1","type":"function"},{"doc":"","ref":"Tyyppi.Value.html#list/2","title":"Tyyppi.Value.list/2","type":"function"},{"doc":"Creates a not defined mfa wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#mfa/0","title":"Tyyppi.Value.mfa/0","type":"function"},{"doc":"Factory for mfa wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#mfa/1","title":"Tyyppi.Value.mfa/1","type":"function"},{"doc":"Factory for mfa wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#mfa/3","title":"Tyyppi.Value.mfa/3","type":"function"},{"doc":"Creates a not defined mod_arg wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#mod_arg/0","title":"Tyyppi.Value.mod_arg/0","type":"function"},{"doc":"Factory for mod_arg wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#mod_arg/1","title":"Tyyppi.Value.mod_arg/1","type":"function"},{"doc":"Factory for mod_arg wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#mod_arg/2","title":"Tyyppi.Value.mod_arg/2","type":"function"},{"doc":"Creates a not defined non_neg_integer() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#non_neg_integer/0","title":"Tyyppi.Value.non_neg_integer/0","type":"function"},{"doc":"Factory for non_neg_integer() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#non_neg_integer/1","title":"Tyyppi.Value.non_neg_integer/1","type":"function"},{"doc":"Creates a one_of value wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#one_of/1","title":"Tyyppi.Value.one_of/1","type":"function"},{"doc":"","ref":"Tyyppi.Value.html#one_of/2","title":"Tyyppi.Value.one_of/2","type":"function"},{"doc":"","ref":"Tyyppi.Value.html#optional/1","title":"Tyyppi.Value.optional/1","type":"function"},{"doc":"Creates a not defined pid() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#pid/0","title":"Tyyppi.Value.pid/0","type":"function"},{"doc":"Factory for pid() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#pid/1","title":"Tyyppi.Value.pid/1","type":"function"},{"doc":"Factory for pid() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#pid/3","title":"Tyyppi.Value.pid/3","type":"function"},{"doc":"Creates a not defined pos_integer() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#pos_integer/0","title":"Tyyppi.Value.pos_integer/0","type":"function"},{"doc":"Factory for pos_integer() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#pos_integer/1","title":"Tyyppi.Value.pos_integer/1","type":"function"},{"doc":"Creates a not defined String.t() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#string/0","title":"Tyyppi.Value.string/0","type":"function"},{"doc":"Factory for String.t() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#string/1","title":"Tyyppi.Value.string/1","type":"function"},{"doc":"Creates a not defined struct wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#struct/0","title":"Tyyppi.Value.struct/0","type":"function"},{"doc":"Factory for struct wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#struct/1","title":"Tyyppi.Value.struct/1","type":"function"},{"doc":"Creates a not defined timeout() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#timeout/0","title":"Tyyppi.Value.timeout/0","type":"function"},{"doc":"Factory for timeout() wrapped by Tyyppi.Value","ref":"Tyyppi.Value.html#timeout/1","title":"Tyyppi.Value.timeout/1","type":"function"},{"doc":"","ref":"Tyyppi.Value.html#validate/2","title":"Tyyppi.Value.validate/2","type":"function"},{"doc":"Type of the coercion function allowed","ref":"Tyyppi.Value.html#t:coercer/0","title":"Tyyppi.Value.coercer/0","type":"type"},{"doc":"Type of the encoder function, that might be used for e. g. Json serialization","ref":"Tyyppi.Value.html#t:encoder/0","title":"Tyyppi.Value.encoder/0","type":"type"},{"doc":"","ref":"Tyyppi.Value.html#t:factory_option/0","title":"Tyyppi.Value.factory_option/0","type":"type"},{"doc":"Type of the generator function, producing the stream of value()","ref":"Tyyppi.Value.html#t:generator/0","title":"Tyyppi.Value.generator/0","type":"type"},{"doc":"","ref":"Tyyppi.Value.html#t:t/0","title":"Tyyppi.Value.t/0","type":"type"},{"doc":"","ref":"Tyyppi.Value.html#t:t/1","title":"Tyyppi.Value.t/1","type":"type"},{"doc":"Type of the validation function allowed","ref":"Tyyppi.Value.html#t:validator/0","title":"Tyyppi.Value.validator/0","type":"type"},{"doc":"Process caching the loaded types information. Whether your application often uses the types information, it makes sense to cache it in a process state, because gathering it takes some time. In such a case your application should start this process in the application’s supervision tree, and call Tyyppi.Stats.rehash!/0 every time when the new module is compiled in the runtime.","ref":"Tyyppi.Stats.html","title":"Tyyppi.Stats","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Tyyppi.Stats.html#child_spec/1","title":"Tyyppi.Stats.child_spec/1","type":"function"},{"doc":"Rehashes the types information currently available in the system. This function should be called after the application has created a module in runtime for this module information to appear in the cache.","ref":"Tyyppi.Stats.html#rehash!/0","title":"Tyyppi.Stats.rehash!/0","type":"function"},{"doc":"Starts the cache process. The optional parameter might contain any payload that will be stored in the process’ state. If a payload has callback :: (-&gt; :ok) parameter, this function will be called every time the types information gets rehashed.","ref":"Tyyppi.Stats.html#start_link/2","title":"Tyyppi.Stats.start_link/2","type":"function"},{"doc":"Retrieves the type information for the type given.","ref":"Tyyppi.Stats.html#type/1","title":"Tyyppi.Stats.type/1","type":"function"},{"doc":"Retrieves all the types information currently available in the system.","ref":"Tyyppi.Stats.html#types/0","title":"Tyyppi.Stats.types/0","type":"function"},{"doc":"Function to be called upon rehashing. When arity is 0 , the full new state would be passed, for arity 1 , added and removed types would be passed, for arity 2 , added , removed , and full state would be passed.","ref":"Tyyppi.Stats.html#t:callback/0","title":"Tyyppi.Stats.callback/0","type":"type"},{"doc":"Types information cache","ref":"Tyyppi.Stats.html#t:info/0","title":"Tyyppi.Stats.info/0","type":"type"},{"doc":"Raw type wrapper. All the macros exported by that module are available in Tyyppi . Require and use Tyyppi instead.","ref":"Tyyppi.T.html","title":"Tyyppi.T","type":"module"},{"doc":"Returns true if the type definition was loaded, false otherwise.","ref":"Tyyppi.T.html#loaded?/1","title":"Tyyppi.T.loaded?/1","type":"function"},{"doc":"","ref":"Tyyppi.T.html#t:ast/0","title":"Tyyppi.T.ast/0","type":"type"},{"doc":"","ref":"Tyyppi.T.html#t:raw/0","title":"Tyyppi.T.raw/0","type":"type"},{"doc":"The type information in a human-readable format. For remote types, it’s gathered from Code.Typespec , for built-in like atom() it’s simply constructed on the fly.","ref":"Tyyppi.T.html#t:t/1","title":"Tyyppi.T.t/1","type":"type"},{"doc":"Example of the nested structure defined with Tyyppi.Struct.defstruct/1 The code of this module follows. use Tyyppi @defaults date_time : Value . date_time ( &quot;1973-09-30 02:30:00Z&quot; ) , struct : % Tyyppi.Example.Value { } defstruct date_time : Value . t ( DateTime . t ( ) ) , struct : Tyyppi.Example.Value . t ( )","ref":"Tyyppi.Example.Nested.html","title":"Tyyppi.Example.Nested","type":"module"},{"doc":"Factory for Elixir.Tyyppi.Example.Nested wrapped by Tyyppi.Value","ref":"Tyyppi.Example.Nested.html#as_value/1","title":"Tyyppi.Example.Nested.as_value/1","type":"function"},{"doc":"See Tyyppi.Struct.flatten/1 .","ref":"Tyyppi.Example.Nested.html#flatten/1","title":"Tyyppi.Example.Nested.flatten/1","type":"function"},{"doc":"See Tyyppi.Struct.flatten/2 .","ref":"Tyyppi.Example.Nested.html#flatten/2","title":"Tyyppi.Example.Nested.flatten/2","type":"function"},{"doc":"Helper guard to match instances of struct Tyyppi.Value","ref":"Tyyppi.Example.Nested.html#is_value/1","title":"Tyyppi.Example.Nested.is_value/1","type":"macro"},{"doc":"Returns the field types of this struct as keyword of {field :: atom, type :: Tyyppi.T.t(term())} pairs.","ref":"Tyyppi.Example.Nested.html#types/0","title":"Tyyppi.Example.Nested.types/0","type":"function"},{"doc":"Updates the struct","ref":"Tyyppi.Example.Nested.html#update/2","title":"Tyyppi.Example.Nested.update/2","type":"function"},{"doc":"This function is supposed to be overwritten in the implementation in cases when custom validation is required. It would be called after all casts and type validations, if the succeeded","ref":"Tyyppi.Example.Nested.html#validate/1","title":"Tyyppi.Example.Nested.validate/1","type":"function"},{"doc":"The type describing this struct. This type will be used to validate upserts when called via Access and/or Tyyppi.Struct.put/3 , Tyyppi.Struct.update/3 , both delegating to generated Tyyppi.Example.Nested.update/2 . Upon insertion, the value will be coerced to the expected type when available, the type itself will be validated, and then the custom validation will be applied when applicable.","ref":"Tyyppi.Example.Nested.html#t:t/0","title":"Tyyppi.Example.Nested.t/0","type":"type"},{"doc":"Example of the structure defined with Tyyppi.Struct.defstruct/1 The original code of this module follows: use Tyyppi @typedoc &quot;The user type defined before `defstruct/1` declaration&quot; @type my_type :: :ok | { :error , term ( ) } @defaults bar : { :ok , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } , baz : { :error , :reason } defstruct foo : nil | atom ( ) , bar : GenServer . on_start ( ) , baz : my_type ( ) defp cast_baz ( true ) , do : :ok defp cast_baz ( false ) , do : { :error , false } defp cast_baz ( value ) , do : value Usage examples iex&gt; put_in ( % Tyyppi.Example.Struct { } , [ :foo ] , :ok ) % Tyyppi.Example.Struct { bar : { :ok , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } , baz : { :error , :reason } , foo : :ok } iex&gt; put_in ( % Tyyppi.Example.Struct { } , [ :foo ] , 42 ) ** (ArgumentError) could not put/update key :foo with value 42 ([foo: [type: [expected: &quot;atom()&quot;, got: 42]]]) iex&gt; put_in ( % Tyyppi.Example.Struct { } , [ :baz ] , true ) % Tyyppi.Example.Struct { bar : { :ok , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } , baz : :ok , foo : nil } iex&gt; put_in ( % Tyyppi.Example.Struct { } , [ :baz ] , false ) % Tyyppi.Example.Struct { bar : { :ok , :erlang . list_to_pid ( &#39;&lt;0.0.0&gt;&#39; ) } , baz : { :error , false } , foo : nil }","ref":"Tyyppi.Example.Struct.html","title":"Tyyppi.Example.Struct","type":"module"},{"doc":"Factory for Elixir.Tyyppi.Example.Struct wrapped by Tyyppi.Value","ref":"Tyyppi.Example.Struct.html#as_value/1","title":"Tyyppi.Example.Struct.as_value/1","type":"function"},{"doc":"See Tyyppi.Struct.flatten/1 .","ref":"Tyyppi.Example.Struct.html#flatten/1","title":"Tyyppi.Example.Struct.flatten/1","type":"function"},{"doc":"See Tyyppi.Struct.flatten/2 .","ref":"Tyyppi.Example.Struct.html#flatten/2","title":"Tyyppi.Example.Struct.flatten/2","type":"function"},{"doc":"Helper guard to match instances of struct Tyyppi.Value","ref":"Tyyppi.Example.Struct.html#is_value/1","title":"Tyyppi.Example.Struct.is_value/1","type":"macro"},{"doc":"Returns the field types of this struct as keyword of {field :: atom, type :: Tyyppi.T.t(term())} pairs.","ref":"Tyyppi.Example.Struct.html#types/0","title":"Tyyppi.Example.Struct.types/0","type":"function"},{"doc":"Updates the struct","ref":"Tyyppi.Example.Struct.html#update/2","title":"Tyyppi.Example.Struct.update/2","type":"function"},{"doc":"This function is supposed to be overwritten in the implementation in cases when custom validation is required. It would be called after all casts and type validations, if the succeeded","ref":"Tyyppi.Example.Struct.html#validate/1","title":"Tyyppi.Example.Struct.validate/1","type":"function"},{"doc":"The user type defined before defstruct/1 declaration","ref":"Tyyppi.Example.Struct.html#t:my_type/0","title":"Tyyppi.Example.Struct.my_type/0","type":"type"},{"doc":"The type describing this struct. This type will be used to validate upserts when called via Access and/or Tyyppi.Struct.put/3 , Tyyppi.Struct.update/3 , both delegating to generated Tyyppi.Example.Struct.update/2 . Upon insertion, the value will be coerced to the expected type when available, the type itself will be validated, and then the custom validation will be applied when applicable.","ref":"Tyyppi.Example.Struct.html#t:t/0","title":"Tyyppi.Example.Struct.t/0","type":"type"},{"doc":"Example of the structure defined with Tyyppi.Struct.defstruct/1 , all values be Tyyppi.Value The original code of this module follows: use Tyyppi @defaults foo : Value . optional ( Value . atom ( ) ) , bar : Value . integer ( 42 ) , baz : Value . date_time ( ~U[1973-09-30 02:46:30Z] ) defstruct foo : Value . t ( atom ( ) ) , bar : Value . t ( integer ( ) ) , baz : Value . t ( DateTime . t ( ) ) def validate_bar ( % Value { value : value } ) when value &lt; 100 , do : { :ok , value } def validate_bar ( % Value { } ) , do : { :error , &quot;Expected a value to be less than 100&quot; } This module defines a struct having two fields, foo of a type Value.t(atom()) , and bar of a type Value.t(integer()) .","ref":"Tyyppi.Example.Value.html","title":"Tyyppi.Example.Value","type":"module"},{"doc":"Factory for Elixir.Tyyppi.Example.Value wrapped by Tyyppi.Value","ref":"Tyyppi.Example.Value.html#as_value/1","title":"Tyyppi.Example.Value.as_value/1","type":"function"},{"doc":"See Tyyppi.Struct.flatten/1 .","ref":"Tyyppi.Example.Value.html#flatten/1","title":"Tyyppi.Example.Value.flatten/1","type":"function"},{"doc":"See Tyyppi.Struct.flatten/2 .","ref":"Tyyppi.Example.Value.html#flatten/2","title":"Tyyppi.Example.Value.flatten/2","type":"function"},{"doc":"Helper guard to match instances of struct Tyyppi.Value","ref":"Tyyppi.Example.Value.html#is_value/1","title":"Tyyppi.Example.Value.is_value/1","type":"macro"},{"doc":"Returns the field types of this struct as keyword of {field :: atom, type :: Tyyppi.T.t(term())} pairs.","ref":"Tyyppi.Example.Value.html#types/0","title":"Tyyppi.Example.Value.types/0","type":"function"},{"doc":"Updates the struct","ref":"Tyyppi.Example.Value.html#update/2","title":"Tyyppi.Example.Value.update/2","type":"function"},{"doc":"This function is supposed to be overwritten in the implementation in cases when custom validation is required. It would be called after all casts and type validations, if the succeeded","ref":"Tyyppi.Example.Value.html#validate/1","title":"Tyyppi.Example.Value.validate/1","type":"function"},{"doc":"","ref":"Tyyppi.Example.Value.html#validate_bar/1","title":"Tyyppi.Example.Value.validate_bar/1","type":"function"},{"doc":"The type describing this struct. This type will be used to validate upserts when called via Access and/or Tyyppi.Struct.put/3 , Tyyppi.Struct.update/3 , both delegating to generated Tyyppi.Example.Value.update/2 . Upon insertion, the value will be coerced to the expected type when available, the type itself will be validated, and then the custom validation will be applied when applicable.","ref":"Tyyppi.Example.Value.html#t:t/0","title":"Tyyppi.Example.Value.t/0","type":"type"},{"doc":"Tyyppi Library bringing erlang typespecs to runtime. Provides on-the-fly type validation, typed structs with upserts validation and more.","ref":"getting-started.html","title":"Tyyppi","type":"extras"},{"doc":"Tyyppi allows the runtime validation of types, specified as specs . To use all the features, one should start Tyyppi.Stats process within the application supervision tree. Internally, the library keeps the types as instances of Tyyppi.T struct. Tyyppi.parse/1 Accepts the type and returns back Tyyppi.T instance. It’s unlikely you’d need to call this macro directly. iex | tyyppi | 1 ▶ Tyyppi . parse atom #⇒ %Tyyppi.T{ # definition: {:type, 0, :atom, []}, # module: nil, # name: nil, # params: [], # quoted: {:atom, [], []}, # source: nil, # type: :built_in # } Remote types are also supported, if they are known to the system. To get an access to remote types, one must start Tyyppi.Stats process by calling Tyyppi.Stats.start_link/1 . iex | tyyppi | 2 ▶ Tyyppi . parse GenServer . on_start #⇒ %Tyyppi.T{ # definition: {:type, 700, :union, # [ # {:type, 0, :tuple, [{:atom, 0, :ok}, {:type, 700, :pid, []}]}, # {:atom, 0, :ignore}, # {:type, 0, :tuple, # [ # {:atom, 0, :error}, # {:type, 700, :union, # [ # {:type, 0, :tuple, # [{:atom, 0, :already_started}, {:type, 700, :pid, []}]}, # {:type, 700, :term, []} # ]} # ]} # ]}, # module: GenServer, # name: :on_start, # params: [], # quoted: {{:., [], [GenServer, :on_start]}, [], []}, # source: &quot;.../lib/elixir/ebin/Elixir.GenServer.beam&quot;, # type: :type # } Tyyppi.of?/2 Validates the term given as the second parameter against type given as the first parameter. iex | tyyppi | 3 ▶ Tyyppi . of? GenServer . on_start ( ) , { :ok , self ( ) } #⇒ true iex | tyyppi | 4 ▶ Tyyppi . of? GenServer . on_start ( ) , :ok #⇒ false Tyyppi.of_type?/2 The same as Tyyppi.of?/2 but it expects an instance of Tyyppy.T (as returned by Tyyppi.parse/1 ) as the first parameter. iex | tyyppi | 5 ▶ type = Tyyppi . parse ( GenServer . on_start ) iex | tyyppi | 6 ▶ Tyyppi . of_type? type , { :ok , self ( ) } #⇒ true Tyyppi.apply/3 Experimental accepts spec type, function and the list of arguments, checks whether the argument list conforms the spec, applies the function if so, checks the result against the spec and returns either {:ok, result} tuple or {:error, {reason, value}} tuple otherwise. See Tyyppi.apply/3 docs for examples and details.","ref":"getting-started.html#dealing-with-types","title":"Tyyppi - Dealing with Types","type":"extras"},{"doc":"Tyyppi provides the handy way to build typed structs. The struct declared with Tyyppi.Struct.defstruct/1 automatically declares the public type with all the fields properly declared, as well as provides the ability to introduce additional validations and casting on per-field basis. It also optionally exposes Access implementation that also would allow upserts if and only the casted value passed validations (both againts the type and a custom validator, if it was declared.)","ref":"getting-started.html#dealing-with-structs","title":"Tyyppi - Dealing with Structs","type":"extras"}]